/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 */
package com.jcg.apachepairpriorityqueueexample;

import java.util.Comparator;
import org.apache.commons.lang3.tuple.Pair;
import java.util.PriorityQueue;

/**
 *
 * @author omozegieaziegbe
 */
public class ApachePairPriorityQueueExample {

    public static void main(String[] args) {

        // Example usage of the Pair class with PriorityQueue
        // PriorityQueue is initialized with the comparator
        PriorityQueue<Pair<String, Integer>> priorityQueue = new PriorityQueue<>(Comparator.comparingInt(Pair::getValue));

        // Adding Pairs to the priority queue
        priorityQueue.add(Pair.of("Finish Article", 3));
        priorityQueue.add(Pair.of("Buy Milk", 1));
        priorityQueue.add(Pair.of("Call Mom", 2));

        // Polling elements from the priority queue
        while (!priorityQueue.isEmpty()) {
            Pair<String, Integer> pair = priorityQueue.poll();
            System.out.println("Priority " + pair.getValue() + " : " + pair.getKey());
        }
    }
}
